Library IEEE;
Use 	IEEE.STD_LOGIC_1164.all;
Use 	IEEE.NUMERIC_STD.all;
Use		IEEE.STD_LOGIC_UNSIGNED.all;

entity brst_cntr is
port (
	brst_end	: out 	std_logic;
	brst_end_m1	: out 	std_logic;
	Reset		: in 	std_logic;
	Clk			: in 	std_logic;
	ld_brst		: in 	std_logic;
	brst_max	: in 	std_logic_vector(8 downto 0)
);
end entity brst_cntr;

architecture brst_cntr_arch of brst_cntr is

	signal count	: std_logic_vector(8 downto 0);

begin

	process (Clk, Reset)
	begin
		if (Reset = '0') then
			count <= (others => '0');
		elsif rising_edge(Clk) then 
			if (ld_brst = '1') then
				count <= brst_max;
			else
				if ( count(8 downto 0)=0 ) then
					count	<= count;
				else
					count 	<= count - 1;
				end if;
			end if;
		end if;
	end process;

	u_brst_end : Process (Reset, Clk) Is
	Begin
		if ( Reset='0' ) then
			brst_end	<= '1';
		elsif ( rising_edge(Clk) ) then
			if ( count(8 downto 0)=2 or count(8 downto 0)=1 or count(8 downto 0)=0 ) then
				brst_end	<= '1';
			else
				brst_end	<= '0';
			end if;
		end if;
	End Process u_brst_end;
	
	u_brst_end_m1 : Process (Reset, Clk) Is
	Begin
		if ( Reset='0' ) then
			brst_end_m1	<= '0';
		elsif ( rising_edge(Clk) ) then
			if ( count(8 downto 0)=3 ) then
				brst_end_m1	<= '1';
			else
				brst_end_m1	<= '0';
			end if;
		end if;
	End Process u_brst_end_m1;

end architecture brst_cntr_arch;
